Public Module modHelpers

    ''' <summary>
    ''' konvertiert etwa "2.11.3 Blabla" nach Integer(){2, 11, 3}
    ''' </summary>
    Private Function StringToNumbs(ByVal S As String) As Integer()
        Dim SpaceIndex As Integer = S.IndexOf(" ")
        If SpaceIndex < 0 Then SpaceIndex = S.Length
        Dim Splitted() As String = S.Substring(0, SpaceIndex).Split("."c)
        Dim RetVal(Splitted.Length - 1) As Integer

        For I As Integer = 0 To Splitted.Length - 1
            RetVal(I) = Integer.Parse(Splitted(I))
        Next
        Return RetVal
    End Function

    ''' <summary>
    ''' Diese Function passt auf den im Framework vorgefertigten 
    ''' generischen Delegaten Comparison(Of T), und kann daher bei 
    ''' List(Of T).Sort() als Comparison angegeben werden
    ''' </summary>
    Public Function NumericStringComparison(ByVal x As String, _
         ByVal y As String) As Integer

        Dim NumbsX As Integer() = StringToNumbs(x)
        Dim NumbsY As Integer() = StringToNumbs(y)
        For I As Integer = 0 To Math.Min(NumbsX.Length, NumbsY.Length) - 1
            Dim C As Integer = NumbsX(I).CompareTo(NumbsY(I))
            If C <> 0 Then Return C
        Next

        ' alle verglichenen Elemente waren gleich
        ' also den Vergleich der Lnge der beiden Arrays zurckgeben
        Return NumbsX.Length.CompareTo(NumbsY.Length)
    End Function

End Module